; AutoTrig.Install   Installation of AUTOTRIG 99
; build 24.11        requires mIRC 5.91 (5.71, 5.82 & 5.9)

; thanks to all users who have contributed suggestions & comments

; Special thanks to burnin for the AT99 logo
; and Audi for the sup4mirc.dll that allows AT99 to check the crc value of files easily
; and HackerOne for allowing AT99 to be used to interface ScanFinder to search for and create model trig lists
; and Xion for caring enough to write an add-on!
; AUTOTRIG by TomT

alias AT_Install {
  if ( [ $version $+  ] !isin 5.715.825.95.91) { beep | if ($?!="N O T I C E $crlf $crlf $+ AUTOTRIG 99.24.11 has been tested with mIRC 5.71, 5.82, 5.9 & 5.91. $crlf $crlf $+ You are using mIRC $version $crlf $crlf $+ Continue installation anyway?" = $false) halt }
  .timer 1 1 /$AT_InstallIntro
  unset %AT^InstallC
}

alias AT_InstallIntro {
  if (($lock(run)) || ($lock(dll))) { echo $?!="AUTORIG 99 $crlf $crlf $+ Please note: it is NECESSARY that you goto mIRC Options, then General, then Lock and UNCHECK 2 boxes, beside /run and /dll $crlf $crlf $+ Install is aborted?" | halt }
  if (($isdir(autotrig)) && ($lines(autotrig\AT_Data2.dat) < 1500)) { set %InstallD AUTORIG 99 features $crlf $crlf $+ Alphabetized Trigger Window $crlf $+ Collection AND .CSV on ONE trigger $crlf $+ Maintain CD Volumes on trigger easily $crlf $+ New Trigger Wizard $crlf $+ New Offer Wizard $crlf $+ Advanced user interfaces $crlf $+ Trigger lists with scan counts | $dialog(at_install,at_install,-4) | if (%AT^InstallC) halt }
  if (($isdir(autotrig)) && ($lines(autotrig\AT_Data2.dat) = 1500)) { set %InstallD AUTORIG 99 upgrades $crlf $crlf $+ Modified to function with mIRC 5.91 $crlf $+ Eliminated A1 protocol recognition $crlf $+ Several bugfixes | set %InstallX 1 | $dialog(at_install,at_install,-4) | set %InstallX 0 | if (%AT^InstallC) halt }
  set %InstallD Interaction between AUTORIG 99 and other scripts you may be using can not be ruled out.  Precautions have been taken to avoid script interaction, however all circumstances can not be accounted for.  It is strongly recommended that you make a copy of your existing mirc folder so you can restore to your previous setup in the event of an installation or operational conflict. | $dialog(at_install,at_install,-4) | if (%AT^InstallC) halt
  if (($isdir(autotrig)) && ($lines(autotrig\AT_Data2.dat) < 1500)) { set %InstallD Upgrading to AUTOTRIG 99 is not to be taken lightly, it will take time.  You will need to rebuild ALL triggers and offers that may already exist. And reset several option items! | $dialog(at_install,at_install,-4) | if (%AT^InstallC) halt }
  dialog -ma at_install at_install
  .timer 1 0 /$AT_Install1
}

alias AT_Install1 {
  did -ra at_install 10 | did -hra at_install 20 Done | did -h at_install 30 | unset %InstallD
  did -a at_install 10 $crlf $+ Installation beginning 
  did -a at_install 10 $crlf $+ Closing open windows 
  window -c @Offer_List| window -c @Trigger_List | window -c @Offers | window -c @Triggers
  if ($dialog(at_control)) dialog -x at_control
  if ($dialog(at_options)) dialog -x at_options
  if ($dialog(trigoff)) dialog -x trigger
  if ($dialog(trigoff)) dialog -x offer
  if ($dialog(at_triggers)) dialog -x at_triggers
  if ($dialog(at_offers)) dialog -x at_offers
  if ($dialog(note)) dialog -c note
  did -a at_install 10 $crlf $+ Turning off timers 
  timer1001 off | timer1002 off | timeroffer* off | .timerspeed* off
  did -a at_install 10 $crlf $+ AT Windows CLOSED, Timers OFF 
  unset %AT_* %AT^* %AM_*
  ctcps on | events on
  set %Install 1

  did -a at_install 10 $crlf $+ Checking for AUTOTRIG folder 
  if ($isdir(AutoTrig) = $false) { mkdir AutoTrig | did -a at_install 10 $crlf $+ AUTOTRIG folder created }
  else did -a at_install 10 $crlf $+ AUTOTRIG folder intact

  did -a at_install 10 $crlf $+ Checking for Backup folder 
  if ($isdir(Backup) = $false) { mkdir Backup | did -a at_install 10 $crlf $+ Backup folder created }
  did -a at_install 10 $crlf $+ Backup folder intact 

  did -a at_install 10 $crlf $+ Checking for existing AUTOTRIG scripts 
  window -c @Install | window -hl @Install
  if ($script(0)) {
    set %AT^IC1 1
    while (%AT^IC1 < $script(0)) {
      aline @Install $script(%AT^IC1)
      inc %AT^IC1
  } }
  set %AT^ITmp1 0 | set %AT^IC 1
  while (%AT^IC < $line(@Install,0)) {
    if (AT_*.mrc iswm $nopath($line(@Install,%AT^IC))) {
      set %AT^ITmp2 1
      set %AT^ITmp " $+ $line(@Install,%AT^IC) $+ "
      if (at_install.mrc !isin %AT^ITmp) {
        .unload -rs %AT^ITmp | inc %AT^ITmp1
        did -a at_install 10 $crlf $+ Unloaded: %AT^ITmp
        if ($exists($line(@Install,%AT^IC))) {
          .copy -o %AT^ITmp backup\ $+ $replace($nopath($line(@Install,%AT^IC)),.mrc,.old)
          .remove %AT^ITmp
    } } }
    inc %AT^IC
  }
  window -c @Install
  if (%AT^ITmp2) did -a at_install 10 $crlf $+ Old AUTOTRIG scripts removed
  else did -a at_install 10 $crlf $+ No old AUTOTRIG scripts found
  unset %AT^ITmp*

  did -a at_install 10 $crlf $+ Checking for defunct files 
  :Tloop | set %AT^ITmp $findfile($mircdir [ $+  [ autotrig ] ] ,*.txt,1,1)
  if (%AT^ITmp) {
    inc %AT^ITmp1
    .copy -o " $+ %AT^ITmp $+ " backup\ $+ $nopath(%AT^ITmp)
    .remove " $+ %AT^ITmp $+ " | goto Tloop
    did -a at_install 10 $crlf $+ Removed: %AT^ITmp
  }
  if (%AT^ITmp1) did -a at_install 10 $crlf $+ Removal of %AT^ITmp1 defunct files
  else did -a at_install 10 $crlf $+ No defunct files found

  while ($findfile($mircdir [ $+  [ autotrig ] ] ,AT_*.mrc,1,1)) {
    .copy -o " $+ $ifmatch $+ " backup\ $+ $replace($nopath($ifmatch),.mrc,.old)
    .remove " $+ $ifmatch $+ "
  }

  did -a at_install 10 $crlf $+ Checking for AT_Data1.dat 
  if ($exists(autotrig\AT_Data1.dat)) { inc %AT^ITmp1 | .copy -o autotrig\AT_Data1.dat backup\AT_Data1.old | .remove autotrig\AT_Data1.dat | did -a at_install 10 $crlf $+ Saving AT_Data1.old }
  else did -a at_install 10 $crlf $+ AT_Data1.dat not found

  did -a at_install 10 $crlf $+ Checking for AT_Data2.dat 
  if ($exists(autotrig\AT_Data2.dat)) { inc %AT^ITmp1 | .copy -o autotrig\AT_Data2.dat backup\AT_Data2.old | .remove autotrig\AT_Data2.dat | did -a at_install 10 $crlf $+ Saving AT_Data2.old }
  else did -a at_install 10 $crlf $+ AT_Data2.dat not found

  did -a at_install 10 $crlf $+ Checking for AT_Data3.dat
  if ($exists(autotrig\AT_Data3.dat)) { inc %AT^ITmp1 | .copy -o autotrig\AT_Data3.dat backup\AT_Data3.old | .remove autotrig\AT_Data3.dat | did -a at_install 10 $crlf $+ Saving AT_Data3.old | set %Install 0 }
  else did -a at_install 10 $crlf $+ AT_Data3.dat not found

  did -a at_install 10 $crlf $+ Checking for AT_Data4.dat
  if ($exists(autotrig\AT_Data4.dat)) { inc %AT^ITmp1 | .copy -o autotrig\AT_Data4.dat backup\AT_Data4.old | .remove autotrig\AT_Data4.dat | did -a at_install 10 $crlf $+ Saving AT_Data4.old }
  else did -a at_install 10 $crlf $+ AT_Data4.dat not found

  if (%AT^ITmp1) did -a at_install 10 $crlf $+ Backup of %AT^ITmp1 files complete 
  else did -a at_install 10 $crlf $+ No outdated files found 

  .rename AT_Data1.da_ autotrig\AT_Data1.dat
  .rename AT_Data2.da_ autotrig\AT_Data2.dat
  if ((%InstallY != 1) && ($exists(backup\at_data2.old)) && ($lines(backup\at_data2.old) > 1499)) {
    did -a at_install 10 $crlf $+ AT_Data1.dat Checking 
    if ($exists(backup\AT_Data1.old)) {
      .copy -o backup\AT_Data1.old autotrig\AT_Data1.dat
      did -a at_install 10 $crlf $+ AT_Data1.dat OK
      did -a at_install 10 $crlf $+ AT_Data2.dat Checking 
    }
    .copy -o backup\AT_Data2.old autotrig\AT_Data2.dat | did -a at_install 10 $crlf $+ AT_Data2.dat OK 
  }
  else { did -a at_install 10 $crlf $+ AT_Data1.dat Created | if (%InstallY != 1) did -a at_install 10 $crlf $+ AT_Data2.dat Checking | did -a at_install 10 $crlf $+ AT_Data2.dat Created  }

  .rename AT_Data3.da_ autotrig\AT_Data3.dat  
  if ((%InstallY != 1) && ($exists(backup\AT_Data3.old))) {
    did -a at_install 10 $crlf $+ AT_Data3.dat Checking 
    if ($gettok($AT_D3(2,9),2,32) < 99.17.09) {
      write -l69 backup\AT_Data3.old $read -nl69 autotrig\AT_Data3.dat
      write -l70 backup\AT_Data3.old $read -nl70 autotrig\AT_Data3.dat
    }
    if ($count($ATx_D3(1,1-),$chr(44)) != 0) {
      at_linemove 7,7,8,9,6,8,12,12,13,14,17,17
      $ATx_sD3(9,9,Trigger)
      $ATx_sD3(16,1, $ATx_D3(9,2) )
      $ATx_sD3(16,2, $ATx_D3(9,5) )
      did -a at_install 10 $crlf $+ AT_Data3.dat Updated 
    }
    else { .copy -o backup\AT_Data3.old autotrig\AT_Data3.dat | did -a at_install 10 $crlf $+ AT_Data3.dat OK  }
  }
  else did -a at_install 10 $crlf $+ AT_Data3.dat Created 

  .rename AT_Data4.da_ autotrig\AT_Data4.dat
  if ((%InstallY != 1) && ($exists(backup\AT_Data4.old))) {
    did -a at_install 10 $crlf $+ AT_Data4.dat Checking
    .copy -o backup\AT_Data4.old autotrig\AT_Data4.dat
    did -a at_install 10 $crlf $+ AT_Data4.dat OK 
  }
  else did -a at_install 10 $crlf $+ AT_Data4.dat Created 


  did -a at_install 10 $crlf $+ Moving NEW support files 
  if ($exists(AT_UnInstall.mr_)) { .copy -o AT_UnInstall.mr_ autotrig\AT_UnInstall.mrc | .remove AT_UnInstall.mr_ }
  if ($exists(AT_Document.htm)) { .copy -o AT_Document.htm autotrig\AT_Document.htm | .remove AT_Document.htm }
  if ($exists(AT_Versions.tx_)) { .copy -o AT_Versions.tx_ AT_Versions.txt | .remove AT_Versions.tx_ }
  if ($exists(AT_Config.da_)) { .copy -o AT_Config.da_ autotrig\AT_Config.dat | .remove AT_Config.da_ }
  if ($exists(AT.bmp)) { if ($exists(autotrig\AT.bmp) = $false) .copy -o AT.bmp autotrig\AT.bmp | .remove AT.bmp }
  if ($exists(backup\AUTOTRIG.txt)) { .copy -o backup\AUTOTRIG.txt autotrig\AUTOTRIG.txt }
  did -a at_install 10 $crlf $+ New support files located 

  did -a at_install 10 $crlf $+ Moving NEW script files 
  if ($exists(AT_1.mr_)) .rename AT_1.mr_ autotrig\AT_1.mrc
  if ($exists(AT_2.mr_)) .rename AT_2.mr_ autotrig\AT_2.mrc
  if ($exists(AT_Control.mr_)) .rename AT_Control.mr_ autotrig\AT_Control.mrc
  if ($exists(AT_Triggers.mr_)) .rename AT_Triggers.mr_ autotrig\AT_Triggers.mrc
  if ($exists(AT_Triggers2.mr_)) .rename AT_Triggers2.mr_ autotrig\AT_Triggers2.mrc
  if ($exists(AT_Offers.mr_)) .rename AT_Offers.mr_ autotrig\AT_Offers.mrc
  if ($exists(AT_Options.mr_)) .rename AT_Options.mr_ autotrig\AT_Options.mrc
  if ($exists(AT_Restore.mr_)) .rename AT_Restore.mr_ autotrig\AT_Restore.mrc
  did -a at_install 10 $crlf $+ New script files located 
  did -a at_install 10 $crlf $+ New script files located 

  did -a at_install 10 $crlf $+ Loading AUTOTRIG script file 
  .load -rs autotrig\AT_1.mrc | did -a at_install 10 $crlf $+ autotrig\AT_1.mrc script file loaded
  .load -rs autotrig\AT_2.mrc | did -a at_install 10 $crlf $+ autotrig\AT_2.mrc script file loaded
  did -a at_install 10 $crlf $+ AUTOTRIG script files loaded 

  did -a at_install 10 $crlf $+ Upgrading system data 
  $AT_setTrigs
  set %AT_TST $read -l1 autotrig\AT_Data3.dat
  $AM_Default
  did -a at_install 10 $crlf $+ System data upgraded 

  did -a at_install 10 $crlf $+ Updating AUTOTRIG Version 
  $AT_sD3(2,9,AUTOTRIG 99.24.11)
  did -a at_install 10 $crlf $+ AUTOTRIG Version updated 

  did -a at_install 10 $crlf $+ Installation script unloading 
  if ($exists(at_install.mrc)) { .rename at_install.mrc autotrig\AT_Install.mrc }
  if ($exists(install.mrc)) { .rename install.mrc autotrig\Install.mrc }
  did -a at_install 10 $crlf $+ Installation COMPLETE! 
  did -vf at_install 20
}

; ***** routine used to set up default variables

alias AM_Default {
  if ($AT_D3(14,2) = 0) $AT_sD3(14,2,$ctime)
  if ($AT_D3(14,3) = 0) $AT_sD3(14,3,$ctime)
  var %AT^ItempNick = $me
  if (%AT^ItempNick = $null) var %AT^ItempNick = trigger
  if ($AT_D3(17,2) = $null) $AT_sD3(17,2, [ %AT^ItempNick $+ .txt ] )
  if ($AT_D3(17,3) = $null) $AT_sD3(17,3, [ %AT^ItempNick ] )
  if ($AT_D3(2,7) = $null) { $AT_sS(57,1) | $AT_sD3(2,7,28.8k) }
  $AT_sD3(2,8,A2)
  if ($AT_D3(64,7) != ~CHANFAIL~) $AT_sD3(64,7,~CHANFAIL~)
  if ($AT_D3(69,1) = $null) $AT_sD3(69,1,*max - mIRC max dcc sends)
  if ($AT_D3(70,1) = $null) $AT_sD3(70,1,*etime - elapsed time of final single trigger in offer)
  if ($AT_D3(71,1) = $null) $AT_sD3(71,1,*fserv - active fserv sessions)
  if ($AT_D3(72,1) = $null) $AT_sD3(72,1,*fmax - maximum fserv sessions)
  if ($AT_D3(7,8) < 1) $AT_sD3(7,8,1)

  ;version 17.05
  if ($gettok($AT_D3(2,9),2,32) < 99.17.05) {
    did -a at_install 10 $crlf $+ Installing version 17.05 specific updates
    if ($exists(C:\Program Files\ACD Systems\ACDSee\ACDSee.exe) = $true) $AT_sS(76,1)
    if ((%Install) || (%InstallY)) goto end
    $AT_sS(53,1)
    $AT_sS(62,0) | if ($AT_D3(3,1) != None) $AT_sS(62,$iif($AT_D3(3,1) != Time,1,2))
    $AT_sS(65,0)
    $AT_sD3(3,1,$AT_D3(3,9)) | $AT_sD3(3,9,)
    $AT_sD3(4,2,$AT_D3(3,4)) | $AT_sD3(3,4,7)
    $AT_sD3(4,3,$AT_D3(3,5)) | $AT_sD3(3,5,0)
    $AT_sD3(4,4,$AT_D3(3,6)) | $AT_sD3(3,6,0)
    $AT_sD3(4,5,$AT_D3(3,4)) | $AT_sD3(3,4,7)
    if ($AT_D3(4,1) = $null) $AT_sD3(4,1,0)
    $AT_sS(41,1)
    $AT_sS(61,1)
    $AT_sS(70,2)
    $AT_sD3(4,7,0) | $AT_sD3(4,8,0) | $AT_sD3(4,9,0)

    set %AT^IC 1 | :loop | inc %AT^IC
    set %AT^Itmp1 $read -nl %AT^IC autotrig\AT_Data3.dat
    set %AT^Itmp %AT^Itmp1
    if (%AT^IC = 21) set %AT^Itmp1 $replace($gettok(%AT^Itmp1,1-9,44),#islander,)
    if (%AT^IC = 69) goto loop
    set %AT^Itmp1 $gettok($replace($gettok(%AT^Itmp1,9-,44),AT_,AT^,AM_,AT^),1,126)
    if (%AT^IC !isin 52 53 54 62) set %AT^Itmp1 $replace(%AT^Itmp1,$chr(44),)
    if (%AT^IC !isin 62) set %AT^Itmp1 $remove(%AT^Itmp1,00)
    set %AT^Itmp1 $gettok(%AT^Itmp,1-8,44) $+ , $+ %AT^Itmp1
    while ($right(%AT^Itmp1,1) = $chr(32)) set %AT^Itmp1 $left(%AT^Itmp1,-1)
    write -l %AT^IC autotrig\AT_Data3.dat %AT^Itmp1
    if (%AT^IC < 105) goto loop
    :end
  }
  ;version 17.24
  if ($gettok($AT_D3(2,9),2,32) < 99.17.24) { 
    $AT_sS(77,1)
    var %AT^Ia1 = 1
    while (%AT^Ia1 < 1500) {
      if ($chr(32) isin $AT_D2(4,%AT^Ia1)) $AT_sD2(4,%AT^Ia1, $replace($AT_D2(4,%AT^Ia1),$chr(32),_) )
      inc %AT^Ia1
    }
    var %AT^Ib1 = $lines(autotrig\autotrig.txt)
    if (%AT^Ib1 > 10000) {
      var %AT^Ib2 = $calc(%AT^Ib1 - 9999)
      var %AT^Ib3 = %AT^Ib2 $+ - $+ %AT^Ib1
      did -a at_install 10 $crlf $+ Saving copy of AT Log
      .copy -o autotrig\autotrig.txt autotrig\autotrig.old
      filter -cr %AT^Ib3 autotrig\autotrig.old autotrig\autotrig.txt
      did -a at_install 10 $crlf $+ Reduced AT Log to proper size
  } }
  ;version 18.03
  if ($gettok($AT_D3(2,9),2,32) < 99.18.03) {
    did -a at_install 10 $crlf $+ Installing version 18.03 specific updates
    $AT_sD3(2,7, $iif($AT_D3(3,8) != $null,$AT_D3(3,8),28.8k) )
    $AT_sD3(3,7,30) | $AT_sD3(3,8,15) | $AT_sD3(3,9,15)
    $AT_sS(79,1) | $AT_sS(80,1)
    $AT_DLaunch(Restore) | $AT_Copy
  }
  ;version 23.01
  if ($gettok($AT_D3(2,9),2,32) < 99.23.01) {
    did -a at_install 10 $crlf $+ Installing version 23.01 specific updates
    $AT_sS(23,1)
    $AT_sS(24,1)
    $AT_sD3(27,1,*.csv)
    $AT_sD3(27,2,*.txt)
    $AT_sD3(27,3,*.ion)
    $AT_sD3(28,1,bad)
    $AT_sD3(28,2,unknown)
    $AT_sD3(30,1,offers 4*title02. 06Type #T for the scan. [*fsize])
    $AT_sD3(31,1,is glad to offer you #T. Type #D to receive the zip!)
    $AT_sD3(32,1,offers NEW *D [ *fsize ] Type #T for file and don't forget a friendly THANKS to scanners!)
    $AT_sD3(33,1,offers 4*title02 [*Fcount/*Vcount]. 06Type #T for the scans and *C for the csv.)
    $AT_sD3(34,1,offers *title scans at *Vcount type #C for the csv then type #T for the fills.)
    $AT_sD3(35,1,offers *title. Type#T for the scans and #C for the csv.)
    $AT_sD3(46,1,*title - name of file)
    $AT_sD3(47,1,*fsize - size of file)
    $AT_sD3(48,1,*Vcount - number of files in CSV)
    $AT_sD3(49,1,*Fcount - number of files in the collection folder)
    $AT_sD3(50,1,*title - name of file)
  }
  ;version 23.02
  if ($gettok($AT_D3(2,9),2,32) < 99.23.02) {
    did -a at_install 10 $crlf $+ Installing version 23.02 specific updates
    $AT_sD3(19,7,5)
    $AT_sD3(19,8,10)
    $AT_sS(32,1)
    $AT_setTrigs(1)
    unset %AT^Trig*
    var %AT^ICq = $read -l20 autotrig\at_data3.dat
    var %AT^ICq1 = %AT^ICq $+ ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
    write -l20 autotrig\AT_Data3.dat %AT^ICq1
  }
  ;version 23.10
  if ($gettok($AT_D3(2,9),2,32) < 99.23.10) {
    $AT_sD3(73,1,*trigson - Triggers online)
    $AT_sD3(74,1,*trigsoff - Triggers offline)
    $AT_sD3(73,1,*trigstot - Total triggers)
} }


; ***** routines to control info in and out of AT_Data files
alias ATx_D3 {
  if ($1 != %AT_T3Last) { set %AT_T3Tmp $read -l [ $+ [ $1 ] ] backup\AT_Data3.old | set %AT_T3Last $1 }
  return $remove($gettok(%AT_T3Tmp,$2,44),$chr(0160))
}
alias ATx_sD3 {
  if ($1 != %AT_T3Last) { set %AT_T3Tmp $read -l [ $+ [ $1 ] ] autotrig\AT_Data3.dat | set %AT_T3Last $1 }
  set %AT_T3Tmp $puttok(%AT_T3Tmp,$3-,$2,44)
  write -l [ $+ [ $1 ] ] autotrig\AT_Data3.dat %AT_T3Tmp | return
}
alias ATx_3 { return $str($chr(0160),3) }
alias ATx_sS {
  set %AT_TST $left(%AT_TST,$calc($1 - 1)) $+ $chr($calc($2 + 48)) $+ $mid(%AT_TST,$calc($1 + 1),999)
  if ($len(%AT_TST) = 80) write -l1 autotrig\AT_Data3.dat %AT_TST | else $AT_VarWarn(3)
}

alias at_linemove {
  set %AT^ITmp 1
  :loop | if ($gettok($1,%AT^ITmp,44)) {
    set %AT^ITmp1 $gettok($1,%AT^ITmp,44)
    set %AT^ITmp2 $gettok($1, $calc(%AT^ITmp + 1) ,44)
    set %AT^ITmp3 $read -l $+ %AT^ITmp1 backup\at_data3.old
    write -l $+ %AT^ITmp2 autotrig\AT_Data3.dat %AT^ITmp3
    inc %AT^ITmp 2
    goto loop
} }

dialog AT_Install {
  size -1 -1 300 340
  box "",5,10 0 280 120
  edit "",10,10 130 280 150,multi read vsbar
  button "Next",20,115 290 70 25,ok
  button "Abort",30,210 290 70 25,cancel
  icon 40,5 20 290 90,at.bmp
  check "Save settings and data from previous installation",50,20 320 270 20
}
on *:dialog:at_install:init:0:{
  did $iif(%InstallX,-cv,-ch) at_install 50
  dialog -t at_install AutoTrig 99.24.11 Installation
  did -ra at_install 10 %InstallD
  did -f at_install 20
}
on *:dialog:at_install:sclick:*:{
  if ($did = 50) { set %InstallY $iif($did(at_install,50).state = 0,1,0) | if (%InstallY) beep 10 10 | halt }
  if ($did isin 20 30) {
    if ($did = 30) goto done
    if (%InstallD) goto end
    if (%Install) $AT_DLAunch(Options)
    dialog -m at_about at_about
    :done | unset %AT^I* %Install*
    dialog -x at_install
    .timer 1 3 /.unload -rs at_install.mrc
    set %AT^InstallC 1
  }
  halt
  :end | dialog -x at_install
}
